#! /usr/bin/env python
import os
import string
import urllib
import urllib2
import db
import threading
import re
import sys
import thread
import time
import util

import sumer

"""

todo: send a HEAD request first, to see if the data is what we want and exists.

todo: make sure the request is proper.

"""

##this is the crawler process. it does nothing but watch the url table for
## new entries.

prefs = util.prefs

##prefs['debug'] = True

db.init()


r_mimetype = re.compile(r"^([^;]+);?")
r_title = re.compile(r"<title>([^<]+)<\/title>", re.I | re.M)

##todo: handle spaces in URLs

def run():
	global prefs, r_mimetype, r_title
	##main loop. get the todo list. if none, wait 200secs. if there are some,
	## crawl those pages, with a wait in between.
	while (True):
		version_check() ## see below
		
		list = getList()
		
		## if the list is empty, sleep.... sleeeeeeep.....
		## crawler sleep is the interval between getting pages. usually short.
		## crawler_delay is the interval between checks for new jobs.
		## these are unfortunate names.
		if (list == None or list == []): 
			time.sleep(prefs['crawler_delay'])
			continue
		
		for row in list:
			url, urlhash = row
			try:
				util.debug( "crawling: " + url )
			
				#page content, header
				data = getPage(url)
				##todo: the httplib is not returning the HTTP status code
				if (data and data[0] != None):
					##extract the first part of the content-type heade
					if data[1]:
						status = data[1].status
						mime = data[1].getheader("content-type")
						mime = r_mimetype.search(mime)
						if mime:
							mime = mime.group(1)
						else:
							mime = util.DEFAULT_MIMETYPE
					else:
						mime = util.DEFAULT_MIMETYPE
					
					##if html, parse the title and a snippet
					title = ''
					desc = ''
					keywords = []
					if mime == util.DEFAULT_MIMETYPE:
						title = r_title.search(data[0])
						if title:
							title = title.group(1)
							util.debug( "TITLE: %s" % title )
							
							keywords = db.extractKw(title)
						else:
							title = ''
							
						text = data[0]
					 ##hack: experimental "middle-third" hack
						if len(text) > 5000:
							third = int(len(text)/3.1)
							text = text[third:third*2]
						
						## 0 == summary
						## 1 == "extracted keywords"
						summary = sumer.summarize(util.striphtml(text), 0.07)
						##todo: goog's are beter than mine.
						##desc = summary[0]
						keywords += summary[1]
						db.addKeywords(' '.join(keywords))
						db.addUrlKwMappings(urlhash, keywords)
							
					if len(title) > 255:
						title = title[0:250] + "..."
						
					if len(desc) > 255:
						desc = desc[0:250] + "..."
					
	
					db.updateLibrary(url, data[0], mime, title, desc)
				
				else:
					db.logCrawlFailure(urlhash)
				
					time.sleep(prefs['crawler_sleep'])
			except:
				db.logCrawlFailure(urlhash)			


def getList():
	try:
		db.init()
		retval = db.getTodoList()
		return retval
	except:
		raise#print "Unexpected error:", sys.exc_info()[0]
		




def getPage(url): #{
	global prefs
	try:
		url = urllib.unquote_plus(url)
		request = urllib2.Request(url)
		request.add_header("User-agent", 
			"Dowser/%s (http://dowser.sourceforge.net)" % util.__version__)
		prox = util.getproxy()
		if prox and prox != {}:
			util.debug("""using proxy: %s""" % prox['http'])
			request.set_proxy(prox['http'], 'http')
		pg = urllib2.urlopen(request)
		return (pg.read(prefs['max_page_size']), pg.info())
	except KeyboardInterrupt:
		raise
	except:
		raise#print "Unexpected error in getPage():", sys.exc_info()[0]
		#raise
#}





## todo: expand mimetypes
magic_hash = {
	'text/html':'html',
	'text/xml':'xml',
	'application/pdf':'pdf',
	'image/jpeg':'jpg',
	'image/gif':'gif',
	'application/x-msword':'doc',
	'application/postscript':'ps',
	'text/rtf':'rtf',
	'image/png':'png',
	'image/pjpeg':'jpg',
	'image/bmp':'bmp',
	'image/x-windows-bmp':'bmp',
	'application/msword':'doc',
	'application/vnd.ms-powerpoint':'ppt'
}


""" 
check the mothership for newer versions

todo: this isn't really germane to the crawler, but it's convenient that it's
invoked at regular intervals.

"""
def version_check():
	if not util.prefs['check_upgrades']: return
	now = time.time()
	
	## if the site goes away we shouldn't pollute with useless traffic.
	last_good = util.prefs['last_good_check']
	if  now - last_good > (86400 * 30):
		return 
	
	last = util.prefs['last_upgrade_check']
	if now - last > (86400 * 7):
		util.debug("version check")
		util.prefs['last_upgrade_check'] = now
		util.saveprefs()
		latest = -1.00
		try:
			latest = getPage("http://dowser.sourceforge.net/latest.php")[0]
			util.debug("latest version: %s" % latest)
			latest = float(latest)
			util.prefs['last_good_check'] = now
			util.saveprefs()
		except:
			util.debug("version check failed.")
			
		if latest > float(util.__version__):
			util.prefs['latest_version'] = latest
			util.saveprefs()
		else:
			#in case there is a mixup/rollback, restore version numer
			util.prefs['latest_version'] = float(util.__version__)
			util.saveprefs()


	
def main():
    
    try:
        run()
    except:
        #main()
		  raise
        
if __name__ == "__main__":
    main()

