#! /usr/bin/env python
import sys
import sqlite
import sha
import string
import re
import time
import urllib
import os
import os.path
import exceptions
import random
import util
import msg

import db_sqlite

prefs = util.prefs

"""
todo: in theory -- no url is hiting this DB without at least one keyword 
and mapping. howver, in normal use, there will be many orphaned keywords.
should there be a garbage daemon job to clear out "useless" keywords?

todo: need to have a try: except: for locked databases... on fail, have it
wait for 10msecs or something and try again, up to three times.

urls & keywords -- always hashed, not incremental ids... yes, it means a 
bigger database. if it gets to be a problem we'll change that.


Many apologies to whomever reads this code -- the algorithims are kind of braindead. and the API is confused.
 
idea: independent database thread? have a "queue", either a real Queue instance, or
ket's be dangerous and just ahve an array other threads append to.

todo: sqlite lib is not threadsafe

todo: multithread the HTTPserver? have to isolate os.environ, std.sysout, etc.
"""




##todo: very naive.
def searchLibrary(keywords):
	global prefs
	words = extractKw(keywords)
	words = [sha.new(w).hexdigest() for w in words]
	q = "','".join(words)
		
	sql = """
		select u.urlHash, u.url, u.title, descr, count(*) as cnt,
			u.size, u.lastcrawled, u.mimetype 
		from url u, map_keyword_url m 
		where m.kwHash in ('%s')
		and u.urlHash=m.urlHash
		and lastCrawled > 0
		group by u.urlHash 
		order by u.lastcrawled desc, cnt desc 
		limit %d """ % (q, prefs['max_page'])
		
	util.debug( sql )
	res = query(sql)
	
	
	
	results = []
	for r in res:
		[desc, title] = map(util.stripper, [r[3], r[2]])
		results.append({'url':r[1], 'hash':r[0], 'title':title, 'count':r[4],
			'desc':desc, 'cached': True, 'size':r[5], 'date':r[6], 'mime':r[7]})
			
	return results
	
## grabs the last X cached urls.
def searchLibraryByLatest(limit=50):
	res = query("""
		select u.urlHash, u.url, u.title, u.descr, 
			lastcrawled, size, mimetype
		from url u
		where u.cachepath is not null
		order by u.lastCrawled desc
		limit %d """ % limit
	)
	
	results = []
	for r in res:
		[desc, title] = map(util.stripper, [r[3], r[2]])
		results.append({'url':r[1], 'hash':r[0], 'title':title,
		'desc':desc, 'cached': True, 'size':r[5], 'date':r[4], 'mime':r[6]})
		
	return results

def deleteKeywords(urlhash):
	sql = "delete from map_keyword_url where urlhash='%s'" % urlhash
	execute(sql)
	
## todo: conflict with updateLibrary()?
def updateUrl(urlhash, title, descr, keywords):
	if len(util.stripper(keywords)) > 2:
		deleteKeywords(urlhash)
		addKeywords(keywords)
		addUrlKwMappings(urlhash, extractKw(keywords))
		
	[title, descr] = [util.stripper(d) for d in [title, descr]]
	[title, descr] = [quote(d) for d in [title, descr]]
	
	title_q = ""
	if len(title) > 0: title_q = " title='%s', " % title 
	
	descr_q = ""
	if len(descr) > 0: descr_q = " descr='%s', " % descr 
	
	sql = "update url set %s %s status=status where urlHash='%s'" % (
		title_q, descr_q, urlhash)
	execute(sql)
	
### get the total size of cached pages
## this does not take the sqlitedatabase size into account
def getCacheSize():
	r = query("""
		select sum(size) as size
		from url
	""")
	
	r = r[0]['size']
	return r

## single url's info
def getUrlInfo(urlHash):
	res=query("""
		select u.urlHash, u.url, u.title, descr, size, lastcrawled, mimetype
		from url u
		where u.urlHash = '%s'
	""" % urlHash)
	
	results = []
	for r in res:
		[desc, title] = map(util.stripper, [r[3], r[2]])
		results.append({'url':r[1], 'hash':r[0], 'title':title, 'desc':desc,
		'size':r[4], 'date':r[5], 'mime':r[6]})
	
	return results[0]
	



import urlparse
def extractDomain(url):
	p = urlparse.urlsplit(url)
	return p[1]

##extracts the "path" part from a URL. strips off trailing slash
def extractPath(url):
	p = urlparse.urlsplit(url)[2]
	if p[-1] == "/":
		p = p[0:-1]
	return p

def reverseDomain(d):
	d = string.split(d, '.')
	d.reverse()
	return '.'.join(d)



##todo: this isn't really feasible beyond 300-500 keywords.	
r_numer = re.compile("[0-9\-\_]")
def getUrlKeywords():
	global r_numer
	r = query("""
		select k.keyword, count(keyword) as cnt
		from keywords k, map_keyword_url m
		where k.kwHash = m.kwHash
		and k.keyword != '' 
		group by k.keyword
		order by keyword
	""")

	if r == []: return r
	
	## convoluted crap to put the alpha entries before the numeric
	num = []
	cnt = 0
	for row in r:
		if row[0] != "" and row[0][0] != "" and r_numer.match(row[0][0]):
			cnt += 1
		else:
			break 
	r = r[cnt:] + r[0:cnt]
	return r

##todo: remove 'orphan' keywords? words that no longer have
## url associations?
def deleteUrl(urlhash):
	sql = "select cachepath from url where urlhash='%s'" % urlhash
	cpath = query(sql)
	print cpath
	if cpath !=[] and len(cpath[0]) == 1:
		deleteCache(cpath[0][0])
					
		execute ("""
			delete from url where urlhash = '%s';
			delete from map_keyword_url where urlhash = '%s';
			delete from cache_history  where urlhash = '%s';
		""" % (urlhash, urlhash, urlhash))
		commit()
	##todo: delete cache, too.

def getKwByUrl(urlhash):
	res = query("""
		select k.keyword as keyword from keywords k, map_keyword_url m
		where m.kwHash = k.kwHash and m.urlHash='%s'
	
	""" % urlhash)
	return [r[0] for r in res]


def getUrlCount():
	r = query("""
		select count(cachepath) as cnt from url where cachepath is not null
	""")
	if r:
		return int(r[0]['cnt']) 
	else:
		return 0
		
def getKwCount():
	r = query("""
		select count(k.kwhash) as cnt from keywords k
	""")
	
	return int(r[0]['cnt']) 
	

def getSearchHistory(lim=30):
	r = query("""
		select keywords 
		from searches
		group by keywords
		order by sid desc
		limit %d 
	""" % lim)
	
	return r


def addUrlKwMappings(urlHash, words):
	for w in words:
		try:
			sql = """insert into map_keyword_url (kwHash, urlHash) 
				values ('%s', '%s')""" % (sha.new(w).hexdigest(), urlHash)
			writeq(sql)
			util.debug(sql)
		except sqlite.IntegrityError:
			## we don't care about dupe errors.
			pass		

##adds a link to the library. the crawler thread reads the url table for
## new additions (i.e., lastCrawled=0) and grabs a copy of the contents.
##todo: need a better naming scheme and debug logging
def addToLibrary(url, title, keywords, desc=""):
	[title, keywords, desc] = map(util.stripper, [title, keywords, desc])

	addKeywords(keywords)
	
	urlHash = sha.new(url).hexdigest()
	
	domain = extractDomain(url)

	writeq ("""
		insert or replace into url (urlHash, url, title, lastCrawled, domain, descr)
		values ('""" + urlHash + """','""" + url + """','""" + title + """', 0, '""" + domain +"""','"""+desc+"""')
	""")
	
	words = extractKw(keywords)
	
	addUrlKwMappings(urlHash, words)
	
##todo: find similarity by a 'fingerprint' of the top 100 tf*idf keywords?
def updateLibrary(url, data, mime, title='', desc='', status=0):

	now = time.time()	
	date = time.strftime("%Y_%m_%d_")
	urlHash = sha.new(url).hexdigest()
	dataHash = sha.new(data).hexdigest()
	size = int(len(data))

	
	##figure out the file extension
	ext = '.html'
	if mime != 'text/html':
		ext = os.path.splitext(urlparse.urlparse(url)[2])[1]
		if ext == '' or ext == '.':
			ext = '.html'
			
			
	cachepath = mkPath2(url) + "/" +  date + dataHash[0:5] + ext
	
	
	## see if the page has changed since last time. If so, save it and add a 
	## note in the cache_history table.
	sql = """select datahash from url 
	where datahash = '%s' and urlHash = '%s' """ % (dataHash, urlHash)
	res = query(sql)
	util.debug( res )
	if not res or res == []:
		writeCache(cachepath, data)
		sql = """
			insert into cache_history values ('%s', %d, '%s', '%s')
		""" % (urlHash, now, dataHash, cachepath)
		writeq(sql)
	else:
		util.debug( "duplicate of previous cache: %s" % dataHash )
		
	##title and desc are optional
	##yay! no app is complete without screwy sql assembly!
	if title:
		title = ", title='%s' " % util.sqlquote(title)
	if desc:
		desc = ", descr='%s' " % util.sqlquote(desc)
		
	## record the crawl
	sql = """
		update url set datahash='%s', lastCrawled=%d, cachepath='%s',
		mimetype='%s', size=%d, status=%d, lastsuccess=%d
		%s 
		%s
		where urlHash = '%s'
	""" % (dataHash, now, cachepath, mime, size, status, now, title, desc, urlHash)
	util.debug( sql )
	writeq(sql)
	
	commit()
	

#### makes the "cache path" on disk.
#### "http://www.foo.com/yadda.html"
####      -becomes-
#### "$HOME/dowser/cache/com/foo/www/yadda.html/2004_10_03_cafeb.html"
####
def mkPath2(url):
	#turns "www.foo.com" into "com/foo/www"
	rdomain = string.join(string.split(reverseDomain(extractDomain(url)), '.'), '/')

	## takes path portion of URL i.e., "/bar/index.html"
	path = extractPath(url)

	##create the full path onto disk if necessary
	util.mkdir(util.home + '/dowser/cache/' + rdomain + path)

	return '/dowser/cache/' + rdomain + path

##writes a "file" to disk
##todo: gzip? of course we should gzip... but portability issues?
def writeCache(path, data):
	try:
		#data = zlib.compressobj().compress(data)
		f = open(util.home + path, 'w')
		res = f.write(data)
		util.debug( res )
		f.close()
	except:
		raise#print "Unexpected error:", sys.exc_info()[0]
		print "   ", sys.exc_info()[1]
		print "   ", sys.exc_info()[2]
	

def readCache(path, limit=-1):
	d = ""
	try:

		f = open(util.gethome() + path, 'r')
		d = f.read(limit)
		f.close()
	except:
		raise#print "Unexpected error:", sys.exc_info()[0]
		print "   ", sys.exc_info()[1]
		print "   ", sys.exc_info()[2]
		
	return d



def deleteCache(cpath):
	try:
		folder = os.path.dirname(util.home + cpath)
		files = os.listdir(folder)
		[os.remove(folder + '/' + f) for f in files]
		os.removedirs(folder)
	except:
		pass

## grabs the list of urls to be crawled.
def getTodoList():
	global prefs
	lim = str((prefs['crawler_retry'] * -1) +1)
	sql = "select url, urlhash from url where lastCrawled between %s and 0" % lim
	return query(sql)

def logCrawlFailure(urlhash):
	writeq("update url set lastcrawled = (lastcrawled -1) where urlhash='%s'" % urlhash)
	
	
	
	

###returns the body of a document from cache
def getCache(urlhash, limit=-1):
	r = query("select url, cachepath, mimetype from url where urlHash='" + urlhash + "'")
	
	
	return {'url':r[0]['url'], 'data':readCache(r[0]['cachepath'], limit), 
		'mimetype':r[0]['mimetype']}

##same as above, but gets a specific version based on the checksum.
def getCacheByCheckum(datahash):
	r = query("""
		select u.url as url, c.cachepath as cachepath, u.mimetype as mimetype
		from url u, cache_history c
		where u.urlHash = c.urlHash and c.datahash='%s'
	""" % datahash)
	
	util.debug( r )

	
	return {'url':r[0]['url'], 'data':readCache(r[0]['cachepath']), 
		'mimetype':r[0]['mimetype']}
	
	
def getCacheHistory(urlHash):
	res = query("""
		select c.datahash, c.cachedate from cache_history c
		where c.urlHash='%s' order by cachedate desc
	""" % urlHash)
	
	return [{'datahash':r[0], 'cachedate':r[1]} for r in res]
	
	
## some bookeeping. send it a raw query, and it will record the search, time,
## and component keywords.
##todo: logSearch?
def recordSearch(data):


	d = re.sub(r"'", "''", data)
	sdate = str(time.time())
	sid = writeq("insert into searches (sdate, keywords) values ('"+sdate+"','"+d+"')")
	
	### add the search/kw mappings
	words = extractKw(data)
	wlist = {}
	for w in words:
		wlist[w] = 0
		
	words = wlist.keys()		
	cnt = 0
	for w in words:
		##keyword-keyword mappings
		for w2 in words[cnt+1:]:
			writeq("""
				insert into map_kw_kw (kw, kw2, sid)
				values ('%s', '%s', %s)
			""" % (w, w2, sid))
		writeq("""
			insert into map_search_kw (sid, kwHash, idx)
			values ("""+str(sid)+""",'"""+w+"""',"""+str(cnt)+""")
		""", False)
		
		addKw(w, False)
		
		cnt = cnt +1
	commit()
	

		
def addKw(w, autocommit=True):
	kwh = sha.new(w).hexdigest()
	sql = "insert into keywords (kwHash, keyword) values ('%s','%s')" % (kwh, w)
	writeq(sql, autocommit)

def quote(data):
	return re.sub(r"'", "''", data)

## adds all the terms in "data" as individual rows in the keywords table.
def addKeywords(data):
	data = quote(data)
	words = extractKw(data)
	[addKw(w) for w in util.dedupe(words)]
		

## looks at your search history and finds keywords that had appeared
## with the given keywords.
##todo: there's a lot of junk in here, working around sql lack of
## union and slow subqueries. not the best stuff.
def relatedKw(keywords):
	words = extractKw(keywords)
	words = [sha.new(w).hexdigest() for w in words]
	q = "','".join(words)
		
	sql = """
		select m.kw2, count(*) as cnt
		from map_kw_kw m
		where (m.kw in ('%s'))
		group by m.kw2
		order by m.kw2, cnt
		limit 12
	""" % (q)
	results = query(sql)
	sql = """
		select m.kw, count(*) as cnt
		from map_kw_kw m
		where (m.kw2 in ('%s'))
		group by m.kw
		order by m.kw, cnt
		limit 12
	""" % (q)
	results = results + query(sql)
	##remove words that wre present in query
	retval = []
	for r in results:
		if not w_list.has_key(r[0]):
			retval.append(r);
	return retval

##hack: todo: xxx: this is not i18n!!
def extractKw(data):
	data = string.strip(data)
	words = re.split(r"[^a-zA-Z0-9\-_]+", string.lower(data))
	retval = {}
	[retval.update({k:0}) for k in words]
	#retval = filter(msg.stopword, retval.keys())
	#print words
	return retval.keys()
	

##implements a "write queue" for inserts n updates
##todo: this is now implemented in db_sqlite
##todo: how about async or deferred writes?
def writeq(sql, autocommit=True):
	try :
		return db_sqlite.execute(sql, autocommit)
	except sqlite.IntegrityError:
		## we don't care about dupe errors.
		pass
	except:
		raise
		
def dump():
	tables = query("select name from sqlite_master where type ='table' order by name")
	for t in tables:
		sql = "select * from %s" % t.name
		rows = query(sql)
		
		print
		print "%s, %d rows" % (t.name, len(rows))
		print "________________________________________________________"
		
		for r in rows:
			print r
				

	
	
##todo: need to know more about cursors n such.
def execute(sql, autocommit=True):
	return db_sqlite.execute(sql, autocommit)
	
def query(sql):
	return db_sqlite.query(sql)
		
def init(private=True):
	db_sqlite.init()
	
def commit():
	db_sqlite.commit()


def shutdown():
	db_sqlite.close()

	
	
		
