#! /usr/bin/env python
"""
interface to browse a particular page's cache history

arguments: urlHash
"""


import os
import string
import urllib
import db
import sys
import search
import time
import msg
import util

## character limit for input to the autosummary function
auto_sum_cutoff = 5000
##########################################################################

def run(env, args, out):

	summarizable = {'text/html':True, 'text/plain':True}

	format = util.header + """
		
		<div class=res >
	
			
			<div class="sidebar">
				<div class="library"><small>
				<b>%(CACHE_HISTORY)s</b><br/>
				<small>%(body)s</small>
				</small></div>
				
				<small> 
				&nbsp;&nbsp;&nbsp;&nbsp;<a
					href="/delete?urlhash=%(urlhash)s">%(DELETE)s</a>
				 </small>
			</div>
			
			<div style="padding-left: 15px;">
			%(urlinfo)s
			</div>
			
			
			
		</div>
	""" + util.footer


	urlHash = urllib.unquote_plus(args['urlHash'])
	
	out.write("Content-type: text/html\n\n")
	

	
	info = {}
	info.update(msg.msg)
	
	db.init()
	res = db.getCacheHistory(urlHash)
	info.update(db.getUrlInfo(urlHash))
	
	info['title'] = util.htmlencode(info['title'])

	
		
	body = []
	
	info['date'] = util.longdate(info['date'])
	info['size'] = util.shortbytes(info['size'])
	info['urlhash'] = urlHash
	
	related = db.getKwByUrl(urlHash)
	
	##auto-summary
	info['summary'] = ""
	if summarizable.has_key(info['mime']):
		import sumer
		text = util.striphtml(db.getCache(urlHash, 20480)['data'])
		
		##hack: experimental "middle-third" hack
		if len(text) > auto_sum_cutoff:
			third = int(len(text)/3.1)
			text = text[third:third*2]
			#text = text[0:auto_sum_cutoff]
		
		summary = sumer.summarize(text, 0.1)
		info['summary'] = summary[0]
		#related += summary[1]
	
	
	##hack: experiment in list comprehension + formatting + join
	## wow -- you CAN write python obfuscated!! :)
	info['related'] = ', '.join([
		"""<a href="/browse?by=kw&q=%s">%s</a>""" % (w,w) for w in util.dedupe(related)
	])
	
	##editable keyword list
	info['kwds'] = ', '.join(util.dedupe(related))
	
	urlinfo = """
	<a href="/cache?urlHash=%(urlhash)s"><h2>%(title)s</h2></a>
	
	<div class="summary"><small>(%(size)s) - %(desc)s</small><br/><br/>
	<small>%(summary)s
	
	<hr/>%(related)s
	
	</small></div>
	
	<b><div class=url><a href=%(url)s>%(url)s</a></div></b>
	
	
	<br/><br/><br/>
	<a name="edit"></a>
	
	<form action="/browse_save">
		<input name="urlHash" value="%(urlhash)s" type="hidden" />
		<input name="title" value="%(title)s" size="60" /><br/>
		
		
		<textarea name="desc" rows="6" cols="60">%(desc)s</textarea><br/>
		
		
		<p>Keywords<br/>
		<textarea name="kwds" rows="3" cols="60">%(kwds)s</textarea>
		</p>
		<input type="submit" value="%(SAVE)s" />
	</form>
	""" % info
	
	## hack: liking these list comprehension hacks. 
	## Gosling, eat your heart out
	body = '\n'.join([
		"""&nbsp;&nbsp;<a href="/cache?dataHash=%s">%s</a><br/>
		""" % (r['datahash'], util.longdate(r['cachedate'])) for r in res
	])



	info.update({'body': body, 'urlinfo':urlinfo})
	
	out.write(format % info)
	
	
	out.flush()
	out.close()
