#! /usr/bin/env python
"""
grabs a page from the local cache and pipes the content to the user's
browser.

arguments:
	urlHash (40-bit SHA hash of the URL)
		--or--
	dataHash (SHA hash of the file contents)
"""

import os
import string
import urllib
import db
import sha
import msg
import util


def run(env, args, out):

	prefs = util.prefs
	
	## this is a cached page after all, so send 'forever' cache headers.
	##not that it helps.
	out.write( "Expires: Sat, 31 Oct 2037 23:23:59 GMT\n")
	out.write( "Cache-control: max-age=86400000, public\n")	
	
	
	


	db.init()
	if args.has_key('urlHash'):
		cache = db.getCache(args['urlHash'])
	elif (args.has_key('dataHash')):
		cache = db.getCacheByCheckum(args['dataHash'])
	else:
		out.write( "Content-type: text/html\n\n")
		out.write( "you silly bugger. you need either a url or data hash.")
		return
		
	
		
	out.write("""Content-type: %s; charset=utf8\n\n""" % cache['mimetype'])
	#out.write( """Content-Disposition: attachment; filename="%s" """ % cache['filename'])
	

	## add pretty header for HTML caches
	##todo:! this breaks "remote" clients.... but base href is necessary.
	## what to do, whtat to do? REMOTE_ADDRESS?
	if cache['mimetype'] == util.DEFAULT_MIMETYPE:
		server = "127.0.0.1:%d" % prefs['port']
		info = msg.msg
		info.update(
			{'url': cache['url'], 
			'urlHash':sha.new(cache['url']).hexdigest(), 'server': server}
		)
		out.write("""
			<BASE HREF="%(url)s">
			<div style=\"background: #DFFDDB; padding: 3px; border: solid 1px #666666;
			width:100%%">
			%(LOCAL_CACHE_FROM)s: <a href=%(url)s>%(url)s</a>  
			&nbsp;&nbsp;[<a href="http://%(server)s/browse_history?urlHash=%(urlHash)s">%(CACHE_HISTORY)s</a>]
			</div><hr />
		""" % info)
	
	
	##dump it!
	out.write(urllib.unquote(cache['data']))
