#! /usr/bin/env python
"""
'prefs' page -- change the port number, allow/disallow remote access,
change language, etc.

"""

import os
import string
import urllib
import db
import sys
import search
import msg
import util


##########################################################################
## adds a "_checked" entry in the table to mark True flags as checked
## in the HTML
def checker(key, prefs):	
	if prefs[key]:
		prefs[key+'_checked'] = "checked=checked"
	else:
		prefs[key+'_checked'] = ""
		
		
def run(env, args, out):

	format = util.header + """
		
		<div class=res>

			<form action="/filters_save">
			
			<div class="inset">
			
			<small>Filters are groups of common flags for your searches.
			These flags are sent along with 	your query to the search engines.
			</small><br /><br />
			<table class="filter">
				<thead>
				<th>&nbsp;</th><th>Name</th><th>Flags</th>
				</thead>
				%(filter_list)s
					
				<!-- blank one -->					
				<tr>
				<td><input type="checkbox" name="new_on" value="1" /></td>
				<td><input size="15" value="" name="new_title" /></td>
				<td><input size="30" value="" name="new_flags" /></td>
				</tr>
			</table>			
			<p>
			<input type="submit" value="%(SAVE)s" />
			</p>
			
			</div>
			
			</form>
			
		</div>
	""" + util.footer

	
	
	out.write("Content-type: text/html\n\n")
	filters = util.prefs['filters']
	
	filter_list = []
	cnt = 0
	for name, f in filters.iteritems():
		checked=""
		cnt += 1
		if f['on']: checked="""checked="checked" """
		filter_list.append("""
			<tr>
			<td><input type="checkbox" name="on" value="%s" %s /></td>
			<td><input size="15" value="%s" name="title" /></td>
			<td><input size="30" value="%s" name="flags" /></td>
			</tr>
		""" % (util.htmlencode(name), checked, 
				util.htmlencode(name), util.htmlencode(f['flags']))
		)
	filter_list = " ".join(filter_list)	
	
	info = {}
	info.update({'filter_list':filter_list})
	info.update(msg.msg)
	out.write(format % info)
	
	out.flush()
	out.close()
