#! /usr/bin/env python
"""
'index' page -- dowser's home page.

"""


import os
import string
import db
import sys
import msg
import util


	


##########################################################################

def run(env, args, out):
	
	format = util.idx_header + """
	
	
		
			%(tips)s
			
	
			<form name="addurl" action="/addurl"><br/><hr/>
			<div >
			<small><small>
			

			
			%(LOCAL_CACHE_STATUS)s
			
				<input name="url" size="10" maxlength="1024" />
				<input type="submit" value="add a url" />
			</small></small>
			</div>
			</form>
			
			%(search_bar)s
			
""" + util.idx_footer
	
	
	out.write( "Content-type: text/html\n\n" )
	
	db.init()
	
	num_kw = db.getKwCount()
	num_pages = db.getUrlCount()
	cache_size = util.shortbytes(db.getCacheSize())
	

	

	info = {'num_pages':num_pages, 'num_kw':num_kw, 'cache_size':cache_size}
	info.update(msg.msg)
	
	## check if this is a 'new' install. if so, insert the 'example'
	## box to get them started.
	## todo: needs i18n
	info['tips'] = ""
	if num_pages < 10:
		info['tips'] = """
			<div class="inset">
			Tip: Try out the example search
			"<a href="/search?q=hamlet+full+text&s=google">hamlet full text</a>".
			</div>
		"""
	
	## check if this is a Gecko-based browser, and offer to add D to the search bar
	##todo: when we get into allowing remote clients, this will break.
	##todo: when the user changes the port *after* adding this search bar,
	## there may be some problems.
	##todo: the .src file has a hard-coded port number.
	info['search_bar'] = ""
	
	## heh. some apple or kde bastard put "(KHTML, like Gecko)" in their
	## USER_AGENT string. demented. demented, I tell you.
	if string.find(env['HTTP_USER_AGENT'], "Gecko/") > -1:
		info['search_bar'] = """
			<script type="text/javascript">
			function addEngine()
			{
			  if ((typeof window.sidebar == "object") && (typeof
			  window.sidebar.addSearchEngine == "function"))
			  {
			    window.sidebar.addSearchEngine(
			      "http://127.0.0.1:%d/media/dowser-moz.src",
			      "http://127.0.0.1:%d/media/dowser-moz.gif",
			      "Dowser",
			      "Web" );
			  }
			  else
			  {
			    alert(name);
			  }
			}
			</script>
			<br/>
			<small><small>
			<a href="javascript:addEngine();">[ Add Dowser to your search bar ]</a>
			</small></small>
		""" % (util.prefs['port'], util.prefs['port'])
	
	info['LOCAL_CACHE_STATUS'] = info['LOCAL_CACHE_STATUS'] % info
	
	out.write(format % info)
	
	out.flush()
	out.close()
