#! /usr/bin/env python

"""
Metasearch for Teoma.com
T is remarkably easy to parse, though it returns HUGEMONGOUS pages.
"""
import urlparse
import urllib
import string
import re
import sys
import util
import os

from meta import getPage

debug = 0

"""
Basic process: strip off header and footer (dataBegin, etc), get rid of useless
tags and such (removeRE), split what's left into "rows" (splitRE) and match
each row against the "link pattern" to extract the url, title, description, etc.

todo: mozilla used to have a nifty metasearch that relied only on a "config"
file. i wonder if they had a better way than this hack'n'slash?
"""
removeRE = r"</?b[^>]*>"
dataBegin = r"""<div id="result">"""
dataEnd = r"<table "
splitRE = r"""<div id="result">"""
match = "^<a href=[^\"]+u=http"


headers = {
	"User-Agent":"Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.6) Gecko/20040206 Firefox/0.8",
	"Accept-Charset":"utf-8,ISO-8859-1;q=0.7,*;q=0.7",
	"Accept-Language":"en-us,en;q=0.5",
	"Accept":"*/*",
	"Accept-Encoding":"identity",
	'Referer':"http://www.teoma.com/",
	'Cookie':'CTST=yes&accepting=yes',
	'Connection':'close'
}

def strip(text): 
	text = string.replace(text, "\n", " ")
	text = re.sub(removeRE, " ", text)
	
	#sidx = string.find(text, dataBegin)
	#eidx = string.find(text, dataEnd)
	
	#if (sidx > -1 and eidx > -1): 
	#	text = text[sidx:eidx]
	
	
	return text


	
def split(text): 
	return re.split(splitRE, text)
 

"""
SAMPLE
<a href="http://tm.wc.ask.com/r?t=an&amp;s=m&amp;uid=01BB9769AE347C514&amp;sid=1693F769AE347C514&amp;qid=241D945859DCD94ABCF167858F46AE69&amp;io=7&amp;sv=za5cb0d8d&amp;o=0&amp;ask=china&amp;uip=4102ae4b&amp;en=te&amp;eo=-100&amp;pt=Embassy+of+People's+Repulic+of+China+in+the+United+States+of+America&amp;ac=24&amp;qs=23&amp;pg=1&amp;ep=1&amp;te_par=109&amp;te_id=&amp;u=http://www.china-embassy.org/" id="Newwindowlink1" onmouseover="return ss('Go to http://www.china-embassy.org/')" onmouseout="cs()" style="border:0px;">Embassy of People's Repulic of <b>China</b> in the United States of America</a> <div><b>China</b>-US Relations ... Visa & Passport ... Overseas Chinese Affairs ... more... <b>China</b>, Russia to conclude WTO talks: Wen(22/09/04)</div> <span class="baseURI">www.china-embassy.org/</span><br /></div><br class="resultSpace" />

"""

r_url_title = re.compile(r"""<a href="[^"]*u=(http[^"]*)[^>]*>([^<]*)</a>\s*<div>([^<]*)</div>""")
def extractResult(text): 
	global r_url_title
	if debug:
		print "Row Text: -------------------------------"
		print text
		print

	

	##extract the title and URL
	p = r_url_title.search(text)
	if (p != None):
		[url, title, desc] = [string.strip(x) for x in [p.group(1), p.group(2), p.group(3)]]
		result = {'url': url, 'title':title, 'desc':desc}
	else:
		return None

	result['cached'] = False ## cause this is a 'live' result

	return result ## as a dictionary object
    
r_links = re.compile(r"<a[^>]+>[^<]*</a>")
def stripLinks(text): 
	global r_links
	return r_links.sub('', text)




def search(query, results=util.ResultList(), lock=None):
	global headers
	page = "http://s.teoma.com/search?u=%d&q=%s&qcat=1&qsrc=1" % (util.prefs['max_page'], urllib.quote_plus(query))
	
	#page="http://127.0.0.1:8000/teoma.html"

	try: 
		print page
		page = getPage(page, headers)
		 
		#print page
		
		page = strip(page)
	
		cnt = 0
		for row in split(page): 
			r = extractResult(row)
			if(r != {}):
				results.append(r)
				cnt = cnt +1
		
	except:
		print "error in meta.search()"
		if lock: lock.release()
		raise

	if lock: 
		lock.release()
		print "teoma releasing"
	return results
